RPBS_Bid = {} --Addon pointer

local Bid_Points = 0
local Current_Bid = 0
local High_Bid = 0
local High_Bidder_Name = "No Winner"

---------------------------------
--UI Elements
---------------------------------
fBidUI = CreateFrame("Frame","frmBidUI",UIParent)

function RPBS_Bid.CreateBidUI()
	fBidUI:SetBackdrop({
		  bgFile="Interface\\DialogFrame\\UI-DialogBox-Background", 
		  edgeFile="Interface\\DialogFrame\\UI-DialogBox-Border", 
		  tile=1, tileSize=32, edgeSize=32, 
		  insets={left=11, right=12, top=12, bottom=11}
	})



	fBidUI:SetWidth(220)
	fBidUI:SetHeight(200)
	fBidUI:SetPoint("CENTER",UIParent)
	fBidUI:EnableMouse(true)
	fBidUI:SetMovable(true)
	fBidUI:RegisterForDrag("LeftButton")
	fBidUI:SetScript("OnDragStart", function(self) self:StartMoving() end)
	fBidUI:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
	fBidUI:SetFrameStrata("MEDIUM")

	fBidUI:SetPoint("CENTER",200,0)

	--create a button to call our functions

	local btnPlaceBid = CreateFrame("Button","btnPlaceBid",fBidUI, "UIPanelButtonTemplate")
	btnPlaceBid:SetSize(80 ,25) -- width, height
	btnPlaceBid:SetText("Place Bid")
	btnPlaceBid:SetPoint("TOP", 0, -60)
	btnPlaceBid:SetScript("OnClick", function() RPBS_Bid.PlaceBid() end)


	local btnBidClose = CreateFrame("Button","btnBidClose",fBidUI, "UIPanelButtonTemplate")
	btnBidClose:SetSize(80 ,25) -- width, height
	btnBidClose:SetText("Close")
	btnBidClose:SetPoint("BOTTOMRIGHT", -15, 10)
	btnBidClose:SetScript("OnClick", function() RPBS_Bid.HideBidUI() end)



	local l1 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l1:SetPoint("TOP", 0, -15)
	l1:SetText("Bidding")

	lItem = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lItem:SetPoint("TOP", 0, -30)
	lItem:SetText("Item for bid")


	local l2 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l2:SetPoint("TOPLEFT", 15, -60)
	l2:SetText("Points")

	lblPoints = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lblPoints:SetPoint("TOPLEFT", 15, -75)

	local l4 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l4:SetPoint("TOPLEFT", 15, -105)
	l4:SetText("High Bid")

	local l4 = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	l4:SetPoint("TOPRIGHT", -15, -105)
	l4:SetText("Your Bid")

	lblHighBid = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lblHighBid:SetPoint("TOPLEFT", 30, -120)

	lblCurrentBid = fBidUI:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	lblCurrentBid:SetPoint("TOPRIGHT", -30, -120)

	fBidUI:Hide()	
	
end

function RPBS_Bid.StartBidding(item)
	Current_Bid = 0
	High_Bid = 0
	High_Bidder_Name = "No Winner"
	lblPoints:SetText(Current_Points)
	lblHighBid:SetText(High_Bid)
	lblCurrentBid:SetText(Current_Bid)
	lItem:SetText(item)
	RPBS_Bid.ShowBidUI()
end

function RPBS_Bid.EndBidding()
	fBidUI:Hide()
	if(bML) then
		VoodooRaid.ShowUI()
	end
end

function RPBS_Bid.ShowBidUI()
	VoodooRaid.HideUI()
	fBidUI:Show()
	SendAddonMessage(CHAT_MSG_PREFIX, "BidWindowOpen-0-" .. UnitName("player"),  VoodooRaid.GetInstanceChannel());
end

function RPBS_Bid.HideBidUI()
	fBidUI:Hide()
	if(bML) then
		SendChatMessage("Bidding has ended. WINNER: " .. High_Bidder_Name,"RAID");
		SendAddonMessage(CHAT_MSG_PREFIX, "EndBidding-" .. High_Bid .. "-" .. High_Bidder_Name,  VoodooRaid.GetInstanceChannel());
		VoodooRaid.ShowUI()
	else
		--SendAddonMessage(CHAT_MSG_PREFIX, "BidWindowClose-0-" .. UnitName("player"),  VoodooRaid.GetInstanceChannel());
	end
end


function RPBS_Bid.PlaceBid()
	if(Current_Bid == Current_Points) then
		message("You have no more points to bid with!")
		return
	end
	if(High_Bid > Current_Points) then
		message("Bidding is beyond your availble points!")
		return
	end
	if(Current_Bid <= High_Bid) then
		Current_Bid = High_Bid + 1
	end

	SendAddonMessage(CHAT_MSG_PREFIX, "PlaceBid-" .. Current_Bid .. "-" .. UnitName("player"), "RAID");
	lblCurrentBid:SetText(Current_Bid)
end

function RPBS_Bid.UpdateHighBid(points)
	local iPoints = tonumber(points)
	if(iPoints > High_Bid) then
		lblHighBid:SetText(points)
		High_Bid = iPoints
	end
end

function RPBS_Bid.UpdateHighBidMaster(points, name)
	local iPoints = tonumber(points)
	if(iPoints > High_Bid) then
		lblHighBid:SetText(points .. " - " .. name)
		High_Bid = iPoints
		High_Bidder_Name = name
	end
end
